﻿
function KS_CSVKeyframes()
{

	var scriptName = "CSV Keyframes";

	//	Begin undo group
	app.beginUndoGroup(scriptName);

	function parseTime(str, frameDuration)
	{
		str = str.replace(/;/g, ':');

		if (str.search(':') > 0)
		{
			var rawValues = str.split(':');
			var values = [0, 0, 0, 0];
			var offset = values.length-rawValues.length;

			for (var i=Math.max(0, offset); i<4; i++)
			{
				values[i] = parseInt(rawValues[i-offset]);
			}

			return (values[0]*60 +values[1])*60 + values[2] + values[3]*frameDuration;
		}

		return parseFloat(str);
	}

	function parseArray(strs, length)
	{
		var values = new Array();

		for (var i=0; i<length; i++)
		{
			if (i < strs.length+1)
			{
				values[i] = parseFloat(strs[i+1]);
			}
			else
			{
				values[i] = 0;
			}
		}

		return values;
	}

	try
	{
		 //	Get the current composition
		 var comp = app.project.activeItem;

		 //	If the composition exists
		 if ( (comp != null) && (comp instanceof CompItem) )
		 {
			//	Get the selected layers and their number
			var layers = comp.selectedLayers;
	 
			if (layers.length == 1)
			{
				var properties = layers[0].selectedProperties;

				if ( properties.length == 1 && properties[0].canVaryOverTime )
				{
					var property = properties[0];
					var type = property.propertyValueType;

					switch (type)
					{
						case PropertyValueType.ThreeD_SPATIAL:
						case PropertyValueType.ThreeD:
						case PropertyValueType.TwoD_SPATIAL:
						case PropertyValueType.TwoD:
						case PropertyValueType.OneD:
						case PropertyValueType.COLOR:
						case PropertyValueType.TEXT_DOCUMENT:

							var file = File.openDialog("Select a CSV file ...", "*csv");
							if (file != null)
							{
								var values;
								var rawValues;
								var frameDuration = comp.frameDuration;

								file.open( 'r' );

								while(!file.eof)
								{
									rawValues = file.readln().split(',');
									if (rawValues.length > 2)
									{
										switch (type)
										{
											case PropertyValueType.ThreeD_SPATIAL:
											case PropertyValueType.ThreeD:
												values = parseArray(rawValues, 3);
												break;
											case PropertyValueType.TwoD_SPATIAL:
											case PropertyValueType.TwoD:
												values = parseArray(rawValues, 2);
												break;
											case PropertyValueType.OneD:
												values = parseFloat(rawValues[1]);
												break;
											case PropertyValueType.COLOR:
												values = parseArray(rawValues, 4);
												break;
											case PropertyValueType.TEXT_DOCUMENT:
												values =  rawValues[1] ;
												break;
										}
										property.setValueAtTime( parseTime(rawValues[0], frameDuration), values);
									}
								}

								file.close();
							}
							break;

						default:
							alert("Unsupported property type", scriptName);
							break;
					}
				}
				else
				{
					//	No property selected
					alert("Please select a keyframeable property", scriptName);
				}
			}
			else
			{
				//	No layer selected
				alert("Please select a layer's property", scriptName);
			}

		 }
		 else
		 {
			//	No composition
				alert("Please open a composition and select a layer's property", scriptName);
		 }
	}
	catch (e)
	{
		alert(e);
	}

	//	End undo group
	app.endUndoGroup();

}

KS_CSVKeyframes();